/*    This file is part of Zmanim.

    Zmanim is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Zmanim is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Zmanim; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "config.h"
#include <string>
#include <iostream>
#include <cctype>
#include <cassert>
#include "day.h"

namespace kenDate{
	using namespace std;
	////////////////////////////////////////////////////////////////////////////
	// Change stuff in here for localization
	namespace{
		const char *dayname___[]= {"","Sunday","Monday","Tuesday",
			"Wednesday", "Thursday","Friday","Saturday"};
	}

	inline string dayName(day d)
	{
		assert (sunday<=d && d <= saturday);
		return dayname___[int(d)];
	}
	////////////////////////////////////////////////////////////////////////////
	
	day& operator++(day& d)
	{
		assert (sunday<=d && d <= saturday);
		int * intD = (int*)&d;// it's a pointer cast and it means to trust me.
		if (d==saturday) d=sunday;
		else (*intD)++;
		return d;
	}
	
	day operator++(day& d,int)
	{
		assert (sunday<=d && d <= saturday);
		day temp=d;
		++d;
		return temp;
	}
	
	day& operator--(day& d)
	{
		assert (sunday<=d && d <= saturday);
		int * intD = (int*)&d;// it's a pointer cast and it means to trust me.
		if (d==sunday) d=saturday;
		else (*intD)--;
		return d;
	}
	
	day operator--(day& d,int)
	{
		assert (sunday<=d && d <= saturday);
		day temp=d;
		--d;
		return temp;
	}
	
	day& operator+=(day& d, signed long numDays)
	{
		assert (sunday<=d && d <= saturday);
		if (numDays<0) return d-=(-numDays);
		else
		{
			for (signed long i=0;i<numDays;i++)
				++d;
		}
		return d;
	}
	
	day& operator-=(day& d, signed long numDays)
	{
		assert (sunday<=d && d <= saturday);
		if (numDays<0) return d+=(-numDays);
		else
		{
			for (signed long i=0;i<numDays;i++)
				--d;
		}
		return d;
	}
	
	day operator+(day d, signed long numDays)
	{
		assert (sunday<=d && d <= saturday);
		numDays%=7;
		d+=numDays;
		return d;
	}
	
	day operator-(day d, signed long numDays)
	{
		assert (sunday<=d && d <= saturday);
		numDays%=7;
		d-=numDays;
		return d;
	}

	ostream& operator<<(ostream& out, const day& theDay)
	{
		assert (sunday<=theDay && theDay <= saturday);
		out << dayName(theDay);
		return out;
	}

	istream& operator>>(istream& in, day& theDay)
	{
		string theSDay;
		in >> theSDay;
		
		// correct case: first letter upper, successive letters lowercase
		string::iterator it=theSDay.begin(); // initialize iterator to second letter
		it++;
		*(theSDay.begin())=toupper(*(theSDay.begin())); // handle first letter
		for (;it<theSDay.end();it++) // handle successive letters
		{
			*it=char(tolower(*it));
		}

		for (int t=1;t<8;t++) // figure out which day it is
		{
			if (theSDay==dayName(day(t))) 
			{
				theDay=day(t);
				return in;
			}
		}
		// we won't make it here if we are successful, be cause we'll return in
		// the for loop
		in.setstate(ios::failbit); // or if it isn't
		return in;
	}
	
	day dayOf(date d)
	{
		day x=saturday;
		x+=d-date(1,1,2000);
		return x;
	}
}
